Rapture = LibStub("AceAddon-3.0"):NewAddon("Rapture", "AceConsole-3.0", "AceEvent-3.0")
RaptureGUI = LibStub("AceGUI-3.0")
media = LibStub("LibSharedMedia-3.0")
candy = LibStub("LibCandyBar-3.0")

local defaults = {
    profile = {
		scale = 1.0,
		xpos = 0,
		ypos = 0,
		colorr = 0, 
		colorg = 0.5, 
		colorb = 1, 
		colora = 1,
		width = 200,
		height = 19,
		texture = "Blizzard"
    },
}

local options = {
  type = "group",
  childGroups = "tab",
  args = {
		info = {
		  name = "Info",
		  desc = "Shows info about the addon",
		  type = 'execute',
		  func = function()
			Rapture:Print("This addon shows a neat bar too see how long cooldown is left on your rapture ability.")
		  end,
		},
		test = {
		  name = "Test",
		  desc = "Test rapture cooldown bar",
		  type = 'execute',
		  func = function()
		  RaptureBAR:SetWidth(Rapture.db.profile.width)
		  RaptureBAR:SetHeight(Rapture.db.profile.height)
		  RaptureBAR:SetTexture(media:Fetch("statusbar", Rapture.db.profile.texture))
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
	bar = {
      type = "group",
      name = "Bar options",
      args = {
	    barposdesc = {
		  order = 1,
          type = "description",
          name = "Bar positioning\n",
          cmdHidden = true
        },
		xpos = {
		  order = 3,
          name = "X",
          desc = "Change horizontal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.xpos end,
          set = function(info, x) 
		  Rapture.db.profile.xpos = x
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		ypos = {
		  order = 6,
          name = "Y",
          desc = "Change veritcal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.ypos end,
          set = function(info, y) 
		  Rapture.db.profile.ypos = y
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		  },
		 nudgeright = {
		  order = 4,
          name = "Right",
          desc = "Nudge right once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.xpos end,
          func = function() 
		  Rapture.db.profile.xpos = Rapture.db.profile.xpos + 1
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgeleft = {
		  order = 2,
          name = "Left",
          desc = "Nudge left once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.xpos end,
          func = function() 
		  Rapture.db.profile.xpos = Rapture.db.profile.xpos - 1
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgeup = {
		  order = 5,
          name = "Up",
          desc = "Nudge up once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.ypos end,
          func = function() 
		  Rapture.db.profile.ypos = Rapture.db.profile.ypos + 1
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgedown = {
		  order = 7,
          name = "Down",
          desc = "Nudge down once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.ypos end,
          func = function() 
		  Rapture.db.profile.ypos = Rapture.db.profile.ypos - 1
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		 },
		scaledesc = {
		  order = 9,
          type = "description",
          name = "\n\nBar options\n",
          cmdHidden = true
        },
		scale = {
		  order = 10,
          name = "Scale",
          desc = "Set scale",
          type = 'range',
          min = 0.5,
          max = 2,
          step = 0.1,
          get = function(info) return Rapture.db.profile.scale end,
          set = function(info, s) 
		  Rapture.db.profile.scale = s
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		width = {
		  order = 11,
          name = "Width",
          desc = "Set width",
          type = 'range',
          min = 10,
          max = 600,
          step = 1,
          get = function(info) return Rapture.db.profile.width end,
          set = function(info, w) 
		  Rapture.db.profile.width = w
		  RaptureBAR:SetWidth(Rapture.db.profile.width)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		height = {
		  order = 12,
          name = "Height",
          desc = "Set height",
          type = 'range',
          min = 1,
          max = 60,
          step = 1,
          get = function(info) return Rapture.db.profile.height end,
          set = function(info, h) 
		  Rapture.db.profile.height = h
		  RaptureBAR:SetHeight(Rapture.db.profile.height)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		texture = {
		  order = 14,
		  type = "select",
		  name = "Texture",
		  desc = "Set the statusbar texture.",
		  values = media:HashTable("statusbar"),
		  dialogControl = "LSM30_Statusbar",
		  get = function(info) return Rapture.db.profile.texture end,
          set = function(info, text) 
		  Rapture.db.profile.texture = text
		  RaptureBAR:SetTexture(media:Fetch("statusbar", Rapture.db.profile.texture))
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
	  },
	},
	colors = {
      type = "group",
      name = "Colors",
      args = {
	  	colordesc = {
		  order = 1,
          type = "description",
          name = "Color changer\n",
          cmdHidden = true
        },
		color = {
		  order = 2,
          name = "Bar color",
          desc = "Set color",
          type = 'color',
		  hasAlpha = true,
          get = function(info) return Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora end,
          set = function(info, r, g, b, a)
		  Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora = r, g, b, a
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		colorrgbadesc = {
		  order = 3,
          type = "description",
          name = "\n\nRGBA changer\n",
          cmdHidden = true
        },
		R = {
		  order = 4,
          name = "Red",
          desc = "Set red color",
          type = 'range',
          min = 0,
          max = 1,
          step = 0.01,
          get = function(info) return Rapture.db.profile.colorr end,
          set = function(info, r)
		  Rapture.db.profile.colorr = r
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		G = {
		  order = 5,
          name = "Green",
          desc = "Set green color",
          type = 'range',
          min = 0,
          max = 1,
          step = 0.01,
          get = function(info) return Rapture.db.profile.colorg end,
          set = function(info, g)
		  Rapture.db.profile.colorg = g
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		B = {
		  order = 6,
          name = "Blue",
          desc = "Set blue color",
          type = 'range',
          min = 0,
          max = 1,
          step = 0.01,
          get = function(info) return Rapture.db.profile.colorb end,
          set = function(info, b)
		  Rapture.db.profile.colorb = b
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
		A = {
		  order = 7,
          name = "Alpha",
          desc = "Set the alpha",
          type = 'range',
          min = 0,
          max = 1,
          step = 0.01,
          get = function(info) return Rapture.db.profile.colora end,
          set = function(info, a)
		  Rapture.db.profile.colora = a
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetDuration(12)
		  RaptureBAR:Start()
		  end,
		},
	  },
	},
  },
}

function Rapture:OnInitialize()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Rapture", "Rapture")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Rapture", options, {"rapture", "rap", "Rapture", "Rap"})
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Rapture", options)
    self.db = LibStub("AceDB-3.0"):New("RaptureDB", defaults, "Default")
	self:RegisterChatCommand("rap", "ChatCommand")
	self:RegisterChatCommand("Rapture", "ChatCommand")
	RaptureBAR = candy:New(media:Fetch("statusbar", Rapture.db.profile.texture), Rapture.db.profile.width, Rapture.db.profile.height)
	RaptureBAR:SetTexture(media:Fetch("statusbar", Rapture.db.profile.texture))
	RaptureBAR:SetScale(Rapture.db.profile.scale)
	RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
	RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
	RaptureBAR:SetLabel("Rapture Cooldown")
	RaptureBAR:SetDuration(12)
end

function Rapture:OnEnable()
	self:Print("Rapture Loaded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if not media:Fetch("statusbar", Rapture.db.profile.texture, true) then Rapture.db.profile.texture = "Blizzard" end
end

function Rapture:SPELL_ENERGIZE(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	local player_name = UnitName("player")
	if spellName == "Rapture" and destName == player_name and sourceName == player_name and spellId == 47755 then
		RaptureBAR:SetTexture(media:Fetch("statusbar", Rapture.db.profile.texture))
		RaptureBAR:SetScale(Rapture.db.profile.scale)
		RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		RaptureBAR:SetLabel("Rapture Cooldown")
		RaptureBAR:SetDuration(12)
		RaptureBAR:Start()
	end
end

function Rapture:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	local func = self[event]
	if (func) then
		func(self, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	end
end

function Rapture:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(Rapture, "rap", "Rapture", input)
    end
end